#ifndef _FRAMECONTROLLER_H
#define _FRAMECONTROLLER_H
/****************************************************************
*	Synchronization and frame rate control section				*
****************************************************************/

#include "application.h"			//	i need some info from the application here
#define NUM_FRAMES_AVERAGED	50

/****************************************************************
*	Frame Rate Controller										*
*	This class represents a simulated controller that tries		*
*	to maintain the animation of frames rendred as smooth as	*
*	possible by licking to a specific frame rate, on slow		*
*	machines the frame rate might fall below, this is normal	*
****************************************************************/
class cFrameController : public singleton<cFrameController>
{
private:

	int				m_FrameRate;
	LONGLONG		cur_time;
	LONGLONG		perf_cnt;
	DWORD			time_count;
	LONGLONG		next_time;
	LONGLONG		last_time;
	bool			perf_flag;


	int frametime;					// same one but for a different function
	int fps_arr[NUM_FRAMES_AVERAGED];/// average from here

	LONGLONG lastTime;

public:


	float	m_DeltaTime;

	//	default constructor 60 fps
	cFrameController()
	{
		m_DeltaTime	=	0		;
		last_time	=	0		;
		lastTime	=	0		;
		perf_flag	=	FALSE	;
		SetFps(200)				;
		Application()->m_ReportFile<<"Control     SubSystem Successfully Initialized"<<endl;
	}

	//	destructor just report the success
	~cFrameController()
	{
		Application()->m_ReportFile<<"Control     SubSystem Successfully ShutDown   "<<endl;
	}

	// this is a called once function which will set the timer necessary for synchronization
	// the frame rate required is given here... by default it is 30
	void SetFps(int fps=30);
	//	this function will return true if the time to render a frame has occured
	bool IsReady();
	//	adjusts the time settings of the frame controller
	//	and calculate the average frame rate
	void Update();
	//	this should be used later for time dependant synchronization
	double GetNewTimeDelta();

};
//	end of class	FRAMECONTROL definition

inline cFrameController*&	FrameController()	{return cFrameController::GetSingletonPtr();}
/*-------------------------------------------------------------*/



#endif //_FRAMECONTROLLER_H