#include "glove.h"
#include "opengl.h"
#include "application.h"

/****************************************************************
*	glove.cpp													*
*	implementation of the glove class							*
*	By SHady el Mously											*
****************************************************************/

//	constructor opens the glove on port
cGlove::cGlove()
{
	//	initialize all initial glove data to zero
	m_GloveType			=	"?"		;
	m_GloveHandedness	=	"NONE"	;
	m_NumSensors		=	0		;
	m_Thumb=m_Index=m_Middle=m_Ring=m_Little=m_Roll=m_Pitch=0;


	//	set the glove pointer to null before starting to open ti
	pGlove	=	0;
	
	
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	Graphics()->InitDrawing2D();
	Graphics()->WriteText(0,0,0xFFFFFF,"trying COM1..");
	Graphics()->EndDrawing2D();
	Graphics()->Flip();
	//	try on com1 ..
	pGlove = fdOpen("COM1");

	//	if failed to open return
	if(!pGlove)
	{
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		Graphics()->InitDrawing2D();
		Graphics()->WriteText(0,0,0xFFFFFF,"trying COM2..");
		Graphics()->EndDrawing2D();
		Graphics()->Flip();
		pGlove = fdOpen("COM2");
	}

	if(!pGlove)
	{
		glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
		Graphics()->InitDrawing2D();
		Graphics()->WriteText(0,0,0xFFFFFF,"Nothing found!");
		Graphics()->EndDrawing2D();
		Graphics()->Flip();
		Sleep(1000);

		return;//Application()->ReportError("No Glove attached to COM port");
	}


	//	get the glove type
	int	glovetype	=	FD_GLOVENONE;

	glovetype = fdGetGloveType(pGlove);
	switch (glovetype)
	{
		case FD_GLOVENONE: m_GloveType = "None"; break;
		case FD_GLOVE7:    m_GloveType = "Glove7"; break;
		case FD_GLOVE7W:   m_GloveType = "Glove7 WireLess"; break;
		case FD_GLOVE16:   m_GloveType = "Glove16"; break;
		case FD_GLOVE16W:  m_GloveType = "Glove16 WireLess"; break;
	}

	//	get glove handedness
	if(fdGetGloveHand(pGlove)==FD_HAND_RIGHT)
		m_GloveHandedness="RIGHT";
	else
	if(fdGetGloveHand(pGlove)==FD_HAND_LEFT)
		m_GloveHandedness="LEFT	";

	//	number of sensors in the glove
	m_NumSensors = fdGetNumSensors(pGlove);

	//	get glove info
	fdGetGloveInfo(pGlove,m_GloveInfo);


}


//	destructor closes the port with the gloves
cGlove::~cGlove()
{
	//	close the glove
	fdClose(pGlove);
}


//	get the glove data
void cGlove::GetData()
{
	//	get all the glove data here
	m_Thumb		=	(int)fdGetSensorRaw(pGlove,FD_THUMBNEAR);
	m_Index		=	(int)fdGetSensorRaw(pGlove,FD_INDEXNEAR);
	m_Middle	=	(int)fdGetSensorRaw(pGlove,FD_MIDDLENEAR);
	m_Ring		=	(int)fdGetSensorRaw(pGlove,FD_RINGNEAR);
	m_Little	=	(int)fdGetSensorRaw(pGlove,FD_LITTLENEAR);
	m_Roll		=	(int)fdGetSensorRaw(pGlove,FD_ROLL);
	m_Pitch		=	(int)fdGetSensorRaw(pGlove,FD_PITCH);
}

//	this function should be used to write the glove information
void cGlove::DrawInfo()
{
	Graphics()->WriteText(0,0,0xFFFFFF,"Glove Type        : %s",m_GloveType);
	Graphics()->WriteText(0,20,0xFFFFFF,"Glove handedness  : %s",m_GloveHandedness);
	Graphics()->WriteText(0,40,0xFFFFFF,"Number of sensors : %d",m_NumSensors);
	Graphics()->WriteText(0,60,0xFFFFFF,"thumb  = %d",m_Thumb);
	Graphics()->WriteText(0,80,0xFFFFFF,"index  = %d",m_Index);
	Graphics()->WriteText(0,100,0xFFFFFF,"middle = %d",m_Middle);
	Graphics()->WriteText(0,120,0xFFFFFF,"ring   = %d",m_Ring);
	Graphics()->WriteText(0,140,0xFFFFFF,"little = %d",m_Little);
	Graphics()->WriteText(0,160,0xFFFFFF,"pitch  = %d",m_Pitch);
	Graphics()->WriteText(0,180,0xFFFFFF,"roll   = %d",m_Roll);
}

/*---------------end of class cGlove implementation------------*/

