#ifndef _TEXTWINDOW_H
#define _TEXTWINDOW_H
/********************************************************************
*	class cTextWindow												*
*	By Shady El Mously												*
*	represents a single text window									*
*	to which characters could be sent								*
*	characters are assumed to come from local host					*
*	or from network or outside										*
********************************************************************/

#include "opengl.h"


class cTextWindow 
{
private:

	float	m_Width;			//	Width of the Window
	float	m_Height;			//	Height of the Window
	float	m_Xpos;				//	starting x position from the left of the screen
	float	m_Ypos;				//	starting y position from top of screen
	int		m_NumCharsPerLine;	//	number of  charcaters perline
	int		m_NumLines;			//	number of lines of characaters
	char**	m_Buffer;			//	a buffer filled with the window characters
	int		m_CurLine;			//	the line in which the cursor is located
	int		m_CurChar;			//	the charcater (x) position in which the cursor is located
	color3	m_Color;			//	color of the window
	cString	m_Label;			//	name of the window
	char	m_ReceivedChar;		//	a received character
	char	m_Cursor;			//	the cursor character (underscore)
	DWORD	m_KeyDelay;			//	delay between accepting new charcaters
	DWORD	m_CurTime;			//	current time
	char	m_LastCharacter;	//	store last character here for repitition check
	bool	m_DelayOnAll;		// if this is true , the delay will work on even different charcaters

public:

	//	the constructor makes a window with the dimentions sent to it
	cTextWindow(int width, int height,char* label=NULL);

	//	destructor has to free up memory used by the buffer
	~cTextWindow()
	{	FreeCharacters();	}

	//	this will free up the memory allocated by the window characters
	void FreeCharacters();

	//	this will allocate characters exactly to the size of the window
	void AllocateCharacters();

	
	
	//	some Set* Functions :


	//	use this to set the repeat delay
	//	and the flag of multiple charcaters, which is usually false
	void SetRepeatDelay(DWORD Del,bool DelayOnAll=false)
	{
		m_KeyDelay		=	Del			;	
		m_DelayOnAll	=	DelayOnAll	;
	}

	//	change the position of the window with this
	void SetPos(float x,float y)
	{
		m_Xpos			=	x;
		m_Ypos			=	Application()->m_Height-y-2;
	}

	//	change the dimensions of the window with this
	void SetDims(float x,float y)
	{
		m_Width			=	x;
		m_Height		=	y;
		AllocateCharacters();
	}


	//	this will center the text window x posiiton
	void Center()
	{	m_Xpos=(Application()->m_Width-m_Width)/2;	}


	//	use this to externaly send characters to the chat window
	void SendCharacter(char c);

	//	this will draw the window, should be called in 2D mode
	void Draw(void);

	//	some control functions for the keypad, the new line, thee back space and 
	//	scrolling up


	//	called when a new line character comes
	void NewLine();

	//	called when a back space comes
	void BackSpace();

	//	scroll up, the upper most line will be lost
	void ScrollUp();
};
#endif // _TEXTWINDOW_H