/****************************************************************
*	winmain.cpp													*
*	this is the code from which the control starts				*
*	off all applications created with this engin will start		*
*	the WinMain is just a simple try-throw-catch block			*
*	which creats all the subsystem singlettons					*
*	then call main()											*
*	then shuts down all the subsystems							*
****************************************************************/

#include "application.h"				//	application class to create the application


/****************************************************************
*	The	 WinMain												*
*	By Shady El Mously											*
*	This is the function in which the control	starts			*
*	this function will start all subsystems at startup			*
*	then call the main program..main()							*
*	then it will release everything								*
*	on error everything will shut down and a message			*
*	will be popped out with the error thrown					*
*	all the directx main objects are going to be release at		*
*	its end														*
*	the function main must be declared in the main CPP file		*
*****************************************************************/


int	WINAPI WinMain(
				   HINSTANCE hinstance,
				   HINSTANCE hprevinstance,
				   LPSTR CommandLine,
				   int nCmdShow
				   )
{


	//	the main application is in the try block.. 
	//	just create the app singletton
	//	run main
	//	then destroy app
	try
	{
		Application()				=	new		cApplication(hinstance);
		Application()->main();
		delete Application();
	}
	//	if we jump here.. an error has occured..
	//	safely shutdown everything..
	//	and a message with the error pops up
	catch(cError& Error)
	{
		//	make the application dead
		if(Application())
		{	
			Application()->m_IsDead	=	true;
			//	wait until all threads terminate
			while(Application()->m_InThread);
		}
		SAFE_DELETE	(Application());
		if(Error.m_Message)
			MessageBox(NULL,Error.m_Message,"FATAL ERROR",MB_OK| MB_ICONINFORMATION);
	}
	return true;
}





